
TARGET = syncwall
TEMPLATE = app


CONFIG += ordered debug_and_release

CONFIG(debug,debug|release) {
	LIBS+=-L../src/3rdparty/qimageblitz/debug/
} else {
	LIBS+=-L../src/3rdparty/qimageblitz/release/
}

unix:!macx:LIBS+= -lX11

# directories setup
isEmpty( INSTALL_PREFIX )  : INSTALL_PREFIX  = /usr/local

isEmpty( INSTALL_BINDIR )  : INSTALL_BINDIR  = $$INSTALL_PREFIX/bin
isEmpty( INSTALL_LIBDIR )  {
    INSTALL_LIBDIR  = $$INSTALL_PREFIX/lib
    #installing to lib64 on 64-bit platforms:
    contains (QMAKE_HOST.arch, x86_64) : INSTALL_LIBDIR = $$INSTALL_PREFIX/lib64
}

isEmpty( INSTALL_MANDIR )  : INSTALL_MANDIR  = $$INSTALL_PREFIX/share/man
isEmpty( INSTALL_DATADIR ) : INSTALL_DATADIR = $$INSTALL_PREFIX/share

isEmpty( MYAPP_INSTALL_DESKTOP ) : MYAPP_INSTALL_DESKTOP = $$INSTALL_DATADIR/applications
isEmpty( MYAPP_INSTALL_PIXMAPS ) : MYAPP_INSTALL_PIXMAPS = $$INSTALL_DATADIR/pixmaps
isEmpty( MYAPP_INSTALL_DATA )    : MYAPP_INSTALL_DATA    = $$INSTALL_DATADIR/$$TARGET
isEmpty( MYAPP_INSTALL_DIR )     : MYAPP_INSTALL_DIR     = $$INSTALL_LIBDIR/$$TARGET
isEmpty( MYAPP_INSTALL_BINDIR )  : MYAPP_INSTALL_BINDIR  = $$INSTALL_BINDIR
isEmpty( MYAPP_INSTALL_MAN )     : MYAPP_INSTALL_MAN     = $$INSTALL_MANDIR/man1
isEmpty( MYAPP_INSTALL_TRANS )   : MYAPP_INSTALL_TRANS   = $$INSTALL_DATADIR/$$TARGET/locale

LIBS += -L../src/3rdparty/qimageblitz/ -lqimageblitz

HEADERS += \
    ../src/AppSettings.h \
    ../src/BackgroundPainter.h \
    ../src/BackgroundPainterConfigWidget.h \
    ../src/DesktopScene.h \
    ../src/DesktopView.h \
    ../src/ImageView.h \
    ../src/ImageViewer.h \
    ../src/IMessageHandler.h \
    ../src/LogHandler.h \
    ../src/MiscFunctions.h \
    ../src/NetworkManager.h \
    ../src/NetworkManagerConfigWidget.h \
    ../src/Scheduler.h \
    ../src/SchedulerConfigWidget.h \
    ../src/ScreenItem.h \
    ../src/SingleApplication.h \
    ../src/SplashScreen.h \
    ../src/SyncWall.h \
    ../src/ImageInfos.h \
    ../src/SystemIntegration.h \
    ../src/SystemIntegrationConfigWidget.h \
    ../src/WallpaperProvider.h \
    ../src/ListImagesModel.h \
    ../src/TreeImagesView.h \
    ../src/InfosUpdater.h \
    ../src/IconViewDelegate.h \
	../src/ThreadPool.h \
    ../src/TcpServer.h \
    ../src/TcpClient.h \
    ../src/DatabaseManager.h \
    ../src/BackgroundItem.h \
    ../src/StarRating.h \
    ../src/StarEditor.h \
    ../src/StarDelegate.h \
    ../src/NetworkMessage.h \
    ../src/PaypalButton.h \
    ../src/3rdparty/qkeysequencewidget/qkeysequencewidget.h \
    ../src/3rdparty/qkeysequencewidget/qkeysequencewidget_p.h \
    ../src/3rdparty/qxt/qxtglobal.h \
    ../src/3rdparty/qxt/qxtglobalshortcut.h \
	../src/3rdparty/qt-extended/qexifimageheader.h 
    
SOURCES +=  \
    ../src/AppSettings.cpp \
    ../src/BackgroundPainter.cpp \
    ../src/BackgroundPainterConfigWidget.cpp \
    ../src/DesktopScene.cpp \
    ../src/DesktopView.cpp \
    ../src/ImageView.cpp \
    ../src/ImageViewer.cpp \
    ../src/LogHandler.cpp \
    ../src/main.cpp \
    ../src/MiscFunctions.cpp \
    ../src/NetworkManager.cpp \
    ../src/NetworkManagerConfigWidget.cpp \
    ../src/Scheduler.cpp \
    ../src/SchedulerConfigWidget.cpp \
    ../src/ScreenItem.cpp \
    ../src/SingleApplication.cpp \
    ../src/SplashScreen.cpp \
    ../src/SyncWall.cpp \
    ../src/ImageInfos.cpp \
    ../src/SystemIntegration.cpp \
    ../src/SystemIntegrationConfigWidget.cpp \
    ../src/WallpaperProvider.cpp \
    ../src/ListImagesModel.cpp \
    ../src/TreeImagesView.cpp \
    ../src/InfosUpdater.cpp \
    ../src/IconViewDelegate.cpp \
	../src/ThreadPool.cpp \
    ../src/DatabaseManager.cpp \
    ../src/BackgroundItem.cpp \
    ../src/StarRating.cpp \
    ../src/StarEditor.cpp \
    ../src/StarDelegate.cpp \
    ../src/TcpServer.cpp \
    ../src/TcpClient.cpp \
    ../src/NetworkMessage.cpp \
    ../src/PaypalButton.cpp \
    ../src/3rdparty/qkeysequencewidget/qkeysequencewidget.cpp \
    ../src/3rdparty/qxt/qxtglobal.cpp \
    ../src/3rdparty/qxt/qxtglobalshortcut.cpp \
	../src/3rdparty/qt-extended/qexifimageheader.cpp 

    
FORMS += \
    ../ui/BackgroundPainterConfigWidget.ui \
    ../ui/ImageViewer.ui \
    ../ui/NetworkManagerConfigWidget.ui \
    ../ui/SchedulerConfigWidget.ui \
    ../ui/SyncWall.ui \
    ../ui/SystemIntegrationConfigWidget.ui
    
INCLUDEPATH += \
    $${DESTDIR} \
    ../src/3rdparty/qimageblitz \
    ../src/3rdparty/qkeysequencewidget \
    ../src/3rdparty/qxt \
	../src/3rdparty/qt-extended \
    ../src

# OS2 specific
os2:SOURCES -= \
    ../src/3rdparty/qxt/qxtglobal.cpp \
    ../src/3rdparty/qxt/qxtglobalshortcut.cpp
	
os2:HEADERS -= \
    ../src/3rdparty/qxt/qxtglobal.h \
    ../src/3rdparty/qxt/qxtglobalshortcut.h
    
DEFINES += QXT_STATIC MAKE_QIMAGEBLITZ_LIB

win32-msvc*:DEFINES += _CRT_NONSTDC_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _CRT_SECURE_NO_DEPRECATE
    
RESOURCES += ../res/syncwall.qrc

QT += core gui network sql

TRANSLATIONS = ../lang/syncwall_fr.ts ../lang/syncwall_lt.ts ../lang/syncwall_nl.ts ../lang/syncwall_vi.ts ../lang/syncwall_ro.ts

macx:ICON = ../res/syncwall.icns
macx:SOURCES += ../src/3rdparty/qxt/qxtglobalshortcut_mac.cpp
macx:QMAKE_INFO_PLIST =  ./Info.plist
macx:LIBS += -framework  Carbon
macx:QMAKE_POST_LINK += ./postbuild-macx.sh

win32:RC_FILE = ../res/syncwall.rc
win32:SOURCES += ../src/3rdparty/qxt/qxtglobalshortcut_win.cpp

unix:!macx:SOURCES += ../src/3rdparty/qxt/qxtglobalshortcut_x11.cpp


Release:DESTDIR = release
Release:OBJECTS_DIR = release
Release:MOC_DIR = release
Release:RCC_DIR = release
Release:UI_DIR = release

Debug:DESTDIR = debug
Debug:OBJECTS_DIR = debug
Debug:MOC_DIR = debug
Debug:RCC_DIR = debug
Debug:UI_DIR = debug

macx {
    # add auto creation of info.plist file
    VERSION = $$system(grep VERSION ../src/AppSettings.h | awk \' { print $NF }\' | sed   \'s/\"//g\')
    createplist.commands = $$PWD/Info.plist.sh $$VERSION > $$PWD/Info.plist
    createplist.target = Info.plist1
    createplist.depends = FORCE
    PRE_TARGETDEPS += Info.plist1
    QMAKE_EXTRA_TARGETS += createplist
}

# .qm file for mingw and before setup.nsi
win32-g++ {
    # add auto compilation of .ts files
    QMAKE_EXTRA_COMPILERS += copyQtTrans
    for(TRANS,TRANSLATIONS){
    lang = $$replace(TRANS, .*_([^/]*)\\.ts, \\1)
    GLOBALTRANSLATIONS += $$[QT_INSTALL_TRANSLATIONS]/qt_$${lang}.qm
    }
    copyQtTrans.input         =  GLOBALTRANSLATIONS
    copyQtTrans.output        = ${QMAKE_FILE_BASE}.qm
    copyQtTrans.commands      = cp ${QMAKE_FILE_IN} ../lang/
    copyQtTrans.CONFIG       += no_link target_predeps
    
    # add auto compilation of .ts files
    QMAKE_EXTRA_COMPILERS += lrelease 
    lrelease.input         = TRANSLATIONS
    lrelease.output        = ${QMAKE_FILE_PATH}/${QMAKE_FILE_BASE}.qm
    lrelease.commands      = $$[QT_INSTALL_BINS]/lrelease ${QMAKE_FILE_IN} -qm ../lang/${QMAKE_FILE_BASE}.qm
    lrelease.CONFIG       += no_link target_predeps
}


unix {
    # add auto compilation of .ts files
    QMAKE_EXTRA_COMPILERS += lrelease
    lrelease.input         = TRANSLATIONS
    lrelease.output        = ${QMAKE_FILE_BASE}.qm
    lrelease.commands      = $$[QT_INSTALL_BINS]/lrelease ${QMAKE_FILE_IN} -qm ../lang/${QMAKE_FILE_BASE}.qm
    lrelease.CONFIG       += no_link target_predeps
    
    # to copy executable to /usr/local/bin directory
    starter.files = $$PWD//release/syncwall
    starter.path = $$MYAPP_INSTALL_BINDIR

    transl.files = $$PWD/../lang/*.qm
    transl.path = $$MYAPP_INSTALL_TRANS
    
    data.files += $$PWD/../CREDITS.txt $$PWD/../README.txt $$PWD/../AUTHORS.txt $$PWD/../Changelog.txt
    data.path = $$MYAPP_INSTALL_DATA

    # generate desktop file
    VERSION = $$system(grep VERSION $$PWD/../src/AppSettings.h | awk \' { print $NF }\' | sed   \'s/\"//g\')
    system( sh  $$PWD/syncwall-desktop.sh  $$INSTALL_PREFIX $$VERSION > $$PWD/syncwall.desktop )
    desktop.files += syncwall.desktop
    desktop.path = $$MYAPP_INSTALL_DESKTOP

    icons.files += $$PWD/../res/syncwall.png
    icons.path = $$MYAPP_INSTALL_PIXMAPS

    # generate manpage
    system( sh  $$PWD/syncwall-manpage.sh > syncwall.1 )
    system( gzip -9 -f $$PWD/syncwall.1  )
    manual.files += $$PWD/syncwall.1.gz
    manual.path = $$MYAPP_INSTALL_MAN

    INSTALLS += starter transl data desktop icons manual
}



