
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _BACKGROUNDITEM_H_
#define _BACKGROUNDITEM_H_

#include <QtGui/QGraphicsItem>
#include <QtGui/QImage>
#include <QtGui/QGraphicsSceneMouseEvent>

class BackgroundItem :   public QGraphicsItem
{
public:

    BackgroundItem ( QGraphicsItem * parent = 0 );

    virtual QRectF boundingRect() const;
    virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget * /* widget */);

    void setImage(const QImage &,const QSize &size, const QSize &desktopSize);

    void setSize(const QSize &size);
    QSize getSize() const {return m_size; }

    QPointF getOffset() const;
    void setOffset(const QPointF &);

    void setFreezeXAxis(bool);
    void setFreezeYAxis(bool);

protected:

    QVariant itemChange(GraphicsItemChange change, const QVariant &value);

    virtual void mousePressEvent1 ( QGraphicsSceneMouseEvent * event );
    virtual void mouseMoveEvent1 ( QGraphicsSceneMouseEvent * event );
    virtual void mouseReleaseEvent1 ( QGraphicsSceneMouseEvent * event );

private:

    void drawDesktop(QPainter *painter);

    QSize m_size;
    QSize m_desktopSize;
    bool m_freezeXAxis;
    bool m_freezeYAxis;
    QPointF m_offset;

    QImage m_image;
};

#endif // _BACKGROUNDITEM_H_
