
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _INFOSUPDATER_H_
#define _INFOSUPDATER_H_

#include <QtCore/QObject>
#include <QtCore/QQueue>
#include <QtCore/QMutex>

class ImageInfos;
class DatabaseManager;

class InfosUpdater :    public QObject
{
    Q_OBJECT

public:

    InfosUpdater( QObject *parent = 0 );
    ~InfosUpdater();

    void cancel();
    void clearCache();
    bool isRunning();

public slots:

    void check( ImageInfos * );
    void storeInfos( ImageInfos * );
    void removeInfos( const QString &);
    void check( const QList<ImageInfos *> & );

signals:

    void updated(ImageInfos *);
    void finished();

private:

    void run();

    QMutex m_mutex;
    bool m_abort;
    bool m_isRunning;
    QQueue<ImageInfos *>     m_iiQueue;
    DatabaseManager *m_dbm;
};

#endif // _INFOSUPDATER_H_
