
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _SYSTEMINTEGRATIONCONFIGWIDGET_H_
#define _SYSTEMINTEGRATIONCONFIGWIDGET_H_

#include <QtGui/QWidget>

namespace Ui
{
class SystemIntegrationConfigWidget;
}

#include "SystemIntegration.h"

class SystemIntegrationConfigWidget :    public QWidget
{
    Q_OBJECT

public:

    SystemIntegrationConfigWidget(QWidget *parent = 0);
    ~SystemIntegrationConfigWidget();

public slots:

    void on_comboBoxDesktop_activated(int index);
    void applyWallpaper(const QImage &, bool keepWMSettings = false);
    void applyWallpaper(const QList<QImage> &, bool keepWMSettings = false);

    void saveSettings();

private:

    void updateUI();

    Ui::SystemIntegrationConfigWidget *ui;

    SystemIntegration m_system;
};

#endif // _SYSTEMINTEGRATIONCONFIGWIDGET_H_
