
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#include "TreeImagesView.h"

#include <QtCore/QDebug>
#include <QtCore/QModelIndex>
#include <QtGui/QItemSelectionModel>
#include <QtGui/QPainter>

TreeImagesView::TreeImagesView( QWidget *parent )
    : QTreeView( parent )
{
}

void TreeImagesView::paintEvent( QPaintEvent *event )
{
    if( model() && model()->rowCount() > 0 )
    {
        QTreeView::paintEvent( event );
        return;
    }

    QPainter painter( viewport() );

    QPalette palette;

    QPen pen( palette.color( QPalette::Highlight ) );

    QFont font = painter.font();
    font.setBold( true );
    font.setPointSize( font.pointSize() + 10 );

    const QString text = tr( "Add some images to begin" );

    const QFontMetrics fm( font );
    if( fm.width( text ) > viewport()->rect().width() )
        return;

    painter.setPen( pen );
    painter.setFont( font );

    painter.drawText( rect(), Qt::AlignCenter, text );
}
