#ifndef _MAINWINDOWCLIENT_H_
#define _MAINWINDOWCLIENT_H_

#include <QtCore/QDebug>

#include <QtGui/QMainWindow>
#include <QtNetwork/QAbstractSocket>

#include "NetworkMessage.h"

namespace Ui
{
class MainWindowClient;
}

class TcpClient;

class MainWindowClient : public QMainWindow
{
    Q_OBJECT

public:

    explicit MainWindowClient(QWidget *parent = 0);
    ~MainWindowClient();

public slots:

    void on_pushButtonConnectToServer_toggled(bool);
    void on_pushButtonSendMessage_pressed();
    void connectionChanged( QAbstractSocket::SocketState new_state);
    void newReceivedMessage(const NetworkMessage &);

    void on_pushButtonAutoStart_toggled(bool val);

    void on_pushButtonQuit_pressed();

    void on_spinBoxUdpPort_valueChanged(int);
    void on_spinBoxTimeout_valueChanged(int);
    void on_lineEditHost_textChanged(const QString&);
    void newMessage(const QString &mess);

private:

    void saveSettings();
    void loadSettings();

    void prepareConnection();
    void setConnection(bool);

	void send(const NetworkMessage &msg);

    Ui::MainWindowClient *m_ui;

    TcpClient *m_client;
    unsigned int m_counter;

	int m_tcpPort;
	int m_timeout;
    QString m_host;
    bool m_autoStart;

};

#endif // _MAINWINDOWCLIENT_H_
